
#include <stdio.h>
#include <time.h>
#include <graph.h>
#include <string.h>
#include "asiports.h"
#include "ibmkeys.h"
#include "gf.h"

char oldeeprm[0x2000];
int  psize;			/* Size of personality variable */

int  geteeprm(int);
int  cmpeeprm(int);
void puteeprm(void);

extern int combase;

   /***********************************************************************
    ***********************************************************************

	GET EEPROM FUNCTION

    ***********************************************************************
    ***********************************************************************/

int geteeprm(setpgm)
    int setpgm;
{
    char c;
    int i;
    int j;
    int k;
    char *ptr;


   /***********************************************************************
       GET RADIO'S ATTENTION
    ***********************************************************************/
    
    if (setpgm == 0)
    {
    	asiclear(combase, ASINOUT);
    	for(;;)
    	{

	    /* Case 1:  We have just powered up */
    	    asiclear(combase, ASINOUT);
            asiputc(combase, 'U');
            if ( (asigetc_timed(combase, 18*2)) == 0x3e )
	        break;

	    /* Case 2:  We are already in pgm mode */
    	    asiclear(combase, ASINOUT);
            asiputc(combase, 'G');
            asiputc(combase, 'E');
            if ( (asigetc_timed(combase, 18*2)) != ASBUFREMPTY )
	    {   timer(2); 
    	        asiclear(combase, ASINOUT);
		break;
	    }

	    /* Case 3:  We have exited program mode but want to get back in */
	    asibreak(combase, 25);
	    timer(3*18);
    	    asiclear(combase, ASINOUT);
            asiputc(combase, 'U');
            if ( (asigetc_timed(combase, 18*2)) == 0x3e )
	        break;

            printf("\rCan not wake up radio to get personality.  Please cycle the radio's power.");
	    if (gfkbhit())
	    {   c = getkey();
                return(FALSE);
	    }
	    timer(4);
        }
    
        printf("\nRadio is in programming mode\n");

    } /* End of setpgm if statement *.


   /***********************************************************************
	READ RADIO ID DATA

	BYTE 1: RADIO ID
	BYTE 2: RADIO TYPE / BAND SPLIT
	BYTE 3: PERSONALITY SIZE
		  18H --> 6K
		  20H --> 8K
	BYTE 4: HIGH BYTE OF FLASH SOFTWARE REVISION (BCD)
	BYTE 5: LOW  BYTE OF FLASH SOFTWARE REVISION (BCD)
    ***********************************************************************/

    /* Send the binary id request to the radio */
    timer(2);
    asiputc(combase, 'G');
    asiputc(combase, 'E');

    /* Wait for the response to the GE command */
    ptr = &(oldeeprm[1]);
    for (i=1; i<6; i++)
    {
	while ( isrxempty(combase) )
	{ if (gfkbhit())
	    { c = getkey();
	      return(ERROR);
	    }
	}
        *ptr++ = asigetc(combase);
    }    

    ptr = &(oldeeprm[1]);
    printf("The current flash software revision is %04X\n", *(ptr+3) * 256 + *(ptr+4) );
    if ( *(ptr+2) == 0x18 )
    {   printf("Personality size is 6k\n");
	psize = 6 * 1024;
    }
    else if ( *(ptr+2) == 0x20 )
    {   printf("Personality size is 8k\n");
	psize = 0x1f20;
    }
    else
    {   printf("Unknown personality size code %02X\n", *(ptr+2) & 0xff);
	psize = 0;
	return(ERROR);
    }


  /***********************************************************************
	READ IN THE PERSONALITY
    ***********************************************************************/
    ptr = &oldeeprm[0];
    j = 0;
    printf("Saving current personality   ");

    timer(1);
    asiclear(combase, ASINOUT);
    asiputc(combase, 'G');
    asiputc(combase, 'A');
  
    /* Wait for the response to the GA command */
    for (i=0; i<psize; i++)
    {
	while ( isrxempty(combase) )
	{ if (gfkbhit())
	    { c = getkey();
	      return(ERROR);
	    }
	}
        *ptr++ = asigetc(combase);

	/* Flash a star on the display to show computer is still alive */
	if ( j++ == 256 )
	   printf("\b*");
	if ( j == 512 )
	{   printf("\b ");
	    j = 0;
	}
    }    
    printf("\r                                              \r");
    return(OK);


} /* End of geteeprm function */


   /***********************************************************************
    ***********************************************************************

	COMPARE EEPROM FUNCTION

    ***********************************************************************
    ***********************************************************************/

int cmpeeprm(setpgm)
    int setpgm;
{

    char c;
    int i;
    int j;
    int k;
    char *ptr;


   /***********************************************************************
       GET RADIO'S ATTENTION
    ***********************************************************************/
    
    if ( setpgm == 0)
    {
        asiclear(combase, ASINOUT);
        for(;;)
        {
	    /* Case 1:  We have just powered up */
    	    asiclear(combase, ASINOUT);
            asiputc(combase, 'U');
            if ( (asigetc_timed(combase, 18*2)) == 0x3e )
	        break;

	    /* Case 2:  We are already in pgm mode */
    	    asiclear(combase, ASINOUT);
            asiputc(combase, 'G');
            asiputc(combase, 'E');
            if ( (asigetc_timed(combase, 18*2)) != ASBUFREMPTY )
	    {   timer(2); 
    	        asiclear(combase, ASINOUT);
		break;
	    }

	    /* Case 3:  We have exited program mode but want to get back in */
	    asibreak(combase, 25);
	    timer(3*18);
    	    asiclear(combase, ASINOUT);
            asiputc(combase, 'U');
            if ( (asigetc_timed(combase, 18*2)) == 0x3e )
	        break;

            printf("\rCan not wake up radio to get personality.  Please cycle the radio's power.");
	    if (gfkbhit())
	    {   c = getkey();
                return(FALSE);
	    }
	    timer(4);
        }
    
        printf("\nRadio is in programming mode\n");

    } /* End of setpgm if statement */


  /***********************************************************************
	COMPARE THE PERSONALITY
    ***********************************************************************/
    ptr = &oldeeprm[0];
    j = 0;
    k = TRUE;
    timer(4);
    asiclear(combase, ASINOUT);
    printf("Comparing current personality   ");
    asiputc(combase, 'G');
    asiputc(combase, 'A');
  
    /* Wait for the response to the GA command */
    for (i=0; i<psize; i++)
    {
	while ( isrxempty(combase) )
	{ if (gfkbhit())
	    { c = getkey();
	      return(FALSE);
	    }
	}
        if ( *ptr++ != (asigetc(combase) & 0xff) )
	{    k = FALSE;
	     /*
	     printf("%4X Does not compare\n", i);
	     */
	}

	/* Flash a star on the display to show computer is still alive */
	if ( j++ == 256 )
	   printf("\b*");
	if ( j == 512 )
	{   printf("\b ");
	    j = 0;
	}
    }    

    printf("\r                                     \r");
    return(k);


} /* End of cmpeeprm function */



   /***********************************************************************
    ***********************************************************************

	PUT EEPROM FUNCTION

    ***********************************************************************
    ***********************************************************************/

void puteeprm()
{
    char c;
    int i;
    int j;
    int k;
    char *ptr;

    ptr = &oldeeprm[0];
    j = 0;
    timer(2);
    asiclear(combase, ASINOUT);
    printf("Reprogramming current personality   ");

    for (i=0; i<(psize/0x10); i++)
    {
	while ( !istxempty(combase) )
	{ if (gfkbhit())
	    { c = getkey();
	      exit(1);
	    }
	}

	asiputc(combase, 'G');
	asiputc(combase, 'D');
	asiputc(combase, 0x10);
	asiputc(combase, (i*0x10)/256 & 0xff);
	asiputc(combase, (i*0x10) & 0xff);

	for (k=0; k<0x10; k++)
	{
	    asiputc(combase, *ptr++);
	    
	    /* Flash a star on the display to show computer is still alive */
	    if ( j++ == 256 )
	       printf("\b*");
	    if ( j == 512 )
	    {   printf("\b ");
	        j = 0;
	    }
	}

    }
    printf("\r                                     \r");

} /* End of puteeprm() function */
